//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Uaspg.h"
#include "Uhelp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AdvGrid"
#pragma link "advsprd"
#pragma link "CSPIN"
#pragma link "cspin"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{
   if (OpenDialog1->Execute())
   {
    AdvSpreadGrid1->SaveFixedCells = FALSE;
    AdvSpreadGrid1->LoadFromCSV( OpenDialog1->FileName);
    AdvSpreadGrid1->Recalc();

   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton15Click(TObject *Sender)
{
 Help->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About2Click(TObject *Sender)
{
 ShowMessage("TAdvSpreadGrid v1.4 ""\x0D"" 1999-2000 by TMS software");        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
 AdvSpreadGrid1->ShowFormula = CheckBox1->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
 if (CheckBox2->Checked)
  AdvSpreadGrid1->CellNameMode = nmRC;
 else
  AdvSpreadGrid1->CellNameMode = nmA1;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton17Click(TObject *Sender)
{
 int i;
 TGridRect gr;
 TGridRect sr;

 sr = AdvSpreadGrid1->Selection;

 for(i=sr.Left;i<=sr.Right;i++)
 {
   gr=AdvSpreadGrid1->Selection;
   gr.Left=i;
   gr.Right=i;
   AdvSpreadGrid1->Cells[i][sr.Bottom+1]="=SUM("+AdvSpreadGrid1->RangeToName(gr)+")";
 }
 AdvSpreadGrid1->Recalc();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::AdvSpreadGrid1SelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
//  StatusBar1->Panels->Items[0]->Text = AdvSpreadGrid1->CellToName(ACol,ARow);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton16Click(TObject *Sender)
{
 AnsiString s;

 s = AdvSpreadGrid1->CellName[AdvSpreadGrid1->Col][AdvSpreadGrid1->Row];

 if (InputQuery("Edit cell name","Name",s))
  {
  AdvSpreadGrid1->CellName[AdvSpreadGrid1->Col][AdvSpreadGrid1->Row]=s;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Cut1Click(TObject *Sender)
{
 AdvSpreadGrid1->CutSelectionToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Copy1Click(TObject *Sender)
{
 AdvSpreadGrid1->CopySelectionToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Paste1Click(TObject *Sender)
{
 AdvSpreadGrid1->PasteSelectionFromClipboard();

}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
 AdvSpreadGrid1->Clear();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton14Click(TObject *Sender)
{
 if (SaveDialog1->Execute())
  {
   AdvSpreadGrid1->SaveToCSV(SaveDialog1->FileName);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
 Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AdvSpreadGrid1IsCustomFunction(TObject *sender,
      AnsiString &func, bool &match)
{
   if (StrPos(func.c_str(),"BFS"))
    {
    match=TRUE;
    func="BFS";
    }
    else match=FALSE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AdvSpreadGrid1CalcCustomFunction(TObject *sender,
      AnsiString &func, double &param)
{
  if (StrPos(func.c_str(),"BFS"))
   {
   param=param*2;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AdvSpreadGrid1CellFormat(TObject *Sender, int ACol,
      int Arow, AnsiString &format, bool &datetype)
{
 if (ACol==6) datetype=TRUE; else datetype=FALSE;
 if (datetype) format="ddd dd/mm/yyyy";

}
//---------------------------------------------------------------------------



